@prefix doap:  <http://usefulinc.com/ns/doap#> .
@prefix foaf:  <http://xmlns.com/foaf/0.1/> .
@prefix rdf:   <http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
@prefix rdfs:  <http://www.w3.org/2000/01/rdf-schema#> .
@prefix lv2:   <http://lv2plug.in/ns/lv2core#> .
@prefix lv2ui: <http://lv2plug.in/ns/extensions/ui#> .
@prefix time:  <http://lv2plug.in/ns/ext/time#> .
@prefix midi:  <http://lv2plug.in/ns/ext/midi#> .
@prefix atom:  <http://lv2plug.in/ns/ext/atom#> .
@prefix urid:  <http://lv2plug.in/ns/ext/urid#> .
@prefix rsz:   <http://lv2plug.in/ns/ext/resize-port#> .
@prefix pprop: <http://lv2plug.in/ns/ext/port-props#> .
@prefix pset: <http://lv2plug.in/ns/ext/presets#> .
@prefix state: <http://lv2plug.in/ns/ext/state#> .

<https://git.code.sf.net/p/qmidiarp/arp>
    a lv2:Plugin, lv2:MIDIPlugin ;
    doap:name "QMidiArp Arp" ;
    doap:license <http://opensource.org/licenses/GPL-2.0> ;
    doap:maintainer [
        foaf:name "Frank Kober" ;
        foaf:homepage <http://qmidiarp.sourceforge.net> ;
        foaf:mbox <mailto:qmidiarp-devel@lists.sourceforge.net> ;
    ] ;
    lv2:minorVersion 0;
    lv2:requiredFeature <http://lv2plug.in/ns/ext/urid#map> ;
    lv2:optionalFeature lv2:hardRTCapable ;
    lv2:extensionData <http://lv2plug.in/ns/ext/state#interface> ;
    lv2ui:ui <https://git.code.sf.net/p/qmidiarp/arp#ui> ;
    lv2:port [
        a lv2:InputPort, atom:AtomPort ;
        atom:bufferType atom:Sequence ;
        atom:supports midi:MidiEvent ;
        atom:supports time:Position ;
        rsz:minimumSize 1024;
        lv2:designation lv2:control ;
        lv2:index 0;
        lv2:symbol "MidiIn";
        lv2:name "Midi In";
    ] , [
        a lv2:OutputPort, atom:AtomPort ;
        atom:bufferType atom:Sequence ;
        atom:supports midi:MidiEvent ;
        rsz:minimumSize 1024;
        lv2:designation lv2:control ;
        lv2:index 1;
        lv2:symbol "MidiOut";
        lv2:name "Midi Out";
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 2 ;
        lv2:symbol "ATTACK" ;
        lv2:name "Attack" ;
        lv2:default 0.0 ;
        lv2:minimum 0.0 ;
        lv2:maximum 20.0 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 3 ;
        lv2:symbol "RELEASE" ;
        lv2:name "Release" ;
        lv2:default 0.0 ;
        lv2:minimum 0.0 ;
        lv2:maximum 20.0 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 4 ;
        lv2:symbol "RANDOM_TICK" ;
        lv2:name "Random Tick" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 127 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 5 ;
        lv2:symbol "RANDOM_LEN" ;
        lv2:name "Random Length" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 127 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 6 ;
        lv2:symbol "RANDOM_VEL" ;
        lv2:name "Random Velocity" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 127 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 7 ;
        lv2:symbol "CH_OUT" ;
        lv2:name "Output Channel" ;
        lv2:portProperty lv2:enumeration, lv2:integer ;
        lv2:scalePoint [ rdfs:label "1"; rdf:value 0 ] ;
        lv2:scalePoint [ rdfs:label "2"; rdf:value 1 ] ;
        lv2:scalePoint [ rdfs:label "3"; rdf:value 2 ] ;
        lv2:scalePoint [ rdfs:label "4"; rdf:value 3 ] ;
        lv2:scalePoint [ rdfs:label "5"; rdf:value 4 ] ;
        lv2:scalePoint [ rdfs:label "6"; rdf:value 5 ] ;
        lv2:scalePoint [ rdfs:label "7"; rdf:value 6 ] ;
        lv2:scalePoint [ rdfs:label "8"; rdf:value 7 ] ;
        lv2:scalePoint [ rdfs:label "9"; rdf:value 8 ] ;
        lv2:scalePoint [ rdfs:label "10"; rdf:value 9 ] ;
        lv2:scalePoint [ rdfs:label "11"; rdf:value 10 ] ;
        lv2:scalePoint [ rdfs:label "12"; rdf:value 11 ] ;
        lv2:scalePoint [ rdfs:label "13"; rdf:value 12 ] ;
        lv2:scalePoint [ rdfs:label "14"; rdf:value 13 ] ;
        lv2:scalePoint [ rdfs:label "15"; rdf:value 14 ] ;
        lv2:scalePoint [ rdfs:label "16"; rdf:value 15 ] ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 15 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 8 ;
        lv2:symbol "CH_IN" ;
        lv2:name "Input Channel" ;
        lv2:portProperty lv2:enumeration, lv2:integer ;
        lv2:scalePoint [ rdfs:label "1"; rdf:value 0 ] ;
        lv2:scalePoint [ rdfs:label "2"; rdf:value 1 ] ;
        lv2:scalePoint [ rdfs:label "3"; rdf:value 2 ] ;
        lv2:scalePoint [ rdfs:label "4"; rdf:value 3 ] ;
        lv2:scalePoint [ rdfs:label "5"; rdf:value 4 ] ;
        lv2:scalePoint [ rdfs:label "6"; rdf:value 5 ] ;
        lv2:scalePoint [ rdfs:label "7"; rdf:value 6 ] ;
        lv2:scalePoint [ rdfs:label "8"; rdf:value 7 ] ;
        lv2:scalePoint [ rdfs:label "9"; rdf:value 8 ] ;
        lv2:scalePoint [ rdfs:label "10"; rdf:value 9 ] ;
        lv2:scalePoint [ rdfs:label "11"; rdf:value 10 ] ;
        lv2:scalePoint [ rdfs:label "12"; rdf:value 11 ] ;
        lv2:scalePoint [ rdfs:label "13"; rdf:value 12 ] ;
        lv2:scalePoint [ rdfs:label "14"; rdf:value 13 ] ;
        lv2:scalePoint [ rdfs:label "15"; rdf:value 14 ] ;
        lv2:scalePoint [ rdfs:label "16"; rdf:value 15 ] ;
        lv2:scalePoint [ rdfs:label "Omni"; rdf:value 16 ] ;
        lv2:default 16 ;
        lv2:minimum 0 ;
        lv2:maximum 16 ;
    ] , [
        a lv2:OutputPort, lv2:ControlPort ;
        lv2:index 9 ;
        lv2:symbol "CURSOR_POS" ;
        lv2:name "Cursor position" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 8192 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 10 ;
        lv2:symbol "ENABLE_RESTARTBYKBD" ;
        lv2:name "Restart" ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 11 ;
        lv2:symbol "ENABLE_TRIGBYKBD" ;
        lv2:name "Trigger" ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 12 ;
        lv2:symbol "MUTE" ;
        lv2:name "Mute Output" ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 13 ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:symbol "LATCH_MODE" ;
        lv2:name "Latch mode" ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 14 ;
        lv2:symbol "OCTAVE_MODE" ;
        lv2:name "Octave Mode" ;
        lv2:portProperty lv2:enumeration, lv2:integer ;
        lv2:scalePoint [ rdfs:label "Static"; rdf:value 0 ] ;
        lv2:scalePoint [ rdfs:label "Up"; rdf:value 1 ] ;
        lv2:scalePoint [ rdfs:label "Down"; rdf:value 2 ] ;
        lv2:scalePoint [ rdfs:label "Bounce"; rdf:value 3 ] ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 3 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 15 ;
        lv2:symbol "OCTAVE_LOW" ;
        lv2:name "Low octave limit" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0.0 ;
        lv2:minimum -3.0 ;
        lv2:maximum 0.0 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 16 ;
        lv2:symbol "OCTAVE_HIGH" ;
        lv2:name "High octave limit" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0.0 ;
        lv2:minimum 0.0 ;
        lv2:maximum 3.0 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 17 ;
        lv2:symbol "INDEX_IN1" ;
        lv2:name "Index In 1" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 127 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 18 ;
        lv2:symbol "INDEX_IN2" ;
        lv2:name "Index In 2" ;
        lv2:portProperty lv2:integer ;
        lv2:default 127 ;
        lv2:minimum 0 ;
        lv2:maximum 127 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 19 ;
        lv2:symbol "RANGE_IN1" ;
        lv2:name "Range In 1" ;
        lv2:portProperty lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 127 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 20 ;
        lv2:symbol "RANGE_IN2" ;
        lv2:name "Range In 2" ;
        lv2:portProperty lv2:integer ;
        lv2:default 127 ;
        lv2:minimum 0 ;
        lv2:maximum 127 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 21 ;
        lv2:symbol "ENABLE_TRIGLEGATO" ;
        lv2:name "Trigger Legato" ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 22 ;
        lv2:symbol "REPEAT_MODE" ;
        lv2:name "Repeat Mode" ;
        lv2:portProperty lv2:enumeration, lv2:integer ;
        lv2:scalePoint [ rdfs:label "Static"; rdf:value 0 ] ;
        lv2:scalePoint [ rdfs:label "Up"; rdf:value 1 ] ;
        lv2:scalePoint [ rdfs:label "Down"; rdf:value 2 ] ;
        lv2:scalePoint [ rdfs:label "Random"; rdf:value 3 ] ;
        lv2:scalePoint [ rdfs:label "As Played"; rdf:value 4 ] ;
        lv2:default 1 ;
        lv2:minimum 0 ;
        lv2:maximum 4 ;
    ] , [
        a lv2:OutputPort, lv2:ControlPort ;
        lv2:index 23 ;
        lv2:portProperty pprop:notOnGUI ;
        lv2:symbol "RPATTERNFLAG" ;
        lv2:name "Receive Pattern Flag" ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 24 ;
        lv2:symbol "DEFER" ;
        lv2:name "Defer mute" ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 25 ;
        lv2:symbol "PATTERN_PRESET" ;
        lv2:name "Pattern Preset" ;
        lv2:portProperty lv2:integer ;
        lv2:portProperty pprop:notOnGUI ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 10 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 26 ;
        lv2:symbol "TRANSPORT_MODE" ;
        lv2:name "Transport Mode" ;
        lv2:portProperty lv2:enumeration, lv2:integer ;
        lv2:scalePoint [ rdfs:label "Free"; rdf:value 0 ] ;
        lv2:scalePoint [ rdfs:label "Host Transport"; rdf:value 1 ] ;
        lv2:default 1 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 27 ;
        lv2:symbol "TEMPO" ;
        lv2:name "Internal Tempo" ;
        lv2:portProperty lv2:integer ;
        lv2:default 120 ;
        lv2:minimum  10 ;
        lv2:maximum 400 ;

    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 28 ;
        lv2:portProperty pprop:notOnGUI ;
        lv2:symbol "HOST_TEMPO" ;
        lv2:name "Host Tempo" ;
        lv2:default 120.0 ;
        lv2:minimum 2.0 ;
        lv2:maximum 400.0 ;
        lv2:designation time:beatsPerMinute ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 29 ;
        lv2:portProperty pprop:notOnGUI ;
        lv2:symbol "HOST_POSITION" ;
        lv2:name "Host Position" ;
        lv2:default 0.0 ;
        lv2:minimum 0.0 ;
        lv2:maximum 100000000000.0 ;
        lv2:designation time:frame ;
    ] , [
        a lv2:InputPort, lv2:ControlPort ;
        lv2:index 30 ;
        lv2:portProperty pprop:notOnGUI ;
        lv2:symbol "HOST_SPEED" ;
        lv2:name "Host Speed (Start/Stop)" ;
        lv2:portProperty lv2:toggled, lv2:integer ;
        lv2:default 0 ;
        lv2:minimum 0 ;
        lv2:maximum 1 ;
        lv2:designation time:speed ;
    ] .

#presets

<https://git.code.sf.net/p/qmidiarp/arp#Pattern01>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Simple 4" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> "0"
	] .

<https://git.code.sf.net/p/qmidiarp/arp#Pattern02>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Simple 8" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">0"
	] .

<https://git.code.sf.net/p/qmidiarp/arp#Pattern03>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Simple 16" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>0"
	] .

<https://git.code.sf.net/p/qmidiarp/arp#Pattern04>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Simple 32" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>>0"
	] .

<https://git.code.sf.net/p/qmidiarp/arp#Pattern05>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Chord 8" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">(0123456789)"
	] .
    
<https://git.code.sf.net/p/qmidiarp/arp#Pattern06>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Chord+Bass 16" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>(01234)0(01234)0"
	] .
    
<https://git.code.sf.net/p/qmidiarp/arp#Pattern07>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Chord Oct 16 A" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>////(0123456789)\\ \\ \\ +(0123456789)"
	] .

<https://git.code.sf.net/p/qmidiarp/arp#Pattern08>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Chord Oct 16 B" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>///0\\ \\ \\ 0+////0\\ \\ \\ \\ -00+0-00+0-00+0-00+0-0"
	] .
    
<https://git.code.sf.net/p/qmidiarp/arp#Pattern09>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Chord Oct 16 C" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>///0\\ \\ \\ 0+////(0123)\\ \\ \\ \\ -00+(1234)-00+0-00+0-00+0-0"
	] .
    
<https://git.code.sf.net/p/qmidiarp/arp#Pattern10>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Fast Chords 1" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>////(0123456789)\\ \\ \\+(0123456789) ////hh(0123456789)ddd\\ \\ ////(0123456789)"
	] .
    
<https://git.code.sf.net/p/qmidiarp/arp#Pattern11>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Fast Chords 2" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>(0123456)p+(0123456)-(01234)(234567)(56789)"
	] .
    
<https://git.code.sf.net/p/qmidiarp/arp#Pattern12>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Fast Chords 3" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> ">>////(0123456789)\\ \\ \\ +(0123456789) ////hh(0123456789)ddd\\ \\ \\ ////(0123456789)-\\(0123456789)\\ \\ \\ (0123456789) ////hh+(0123456789)dd\\ \\ \\ ////-(0123456789)"
	] .

<https://git.code.sf.net/p/qmidiarp/arp#Pattern13>
    a pset:Preset ;
    lv2:appliesTo <https://git.code.sf.net/p/qmidiarp/arp> ;
    rdfs:label "Chords/Glissando 16" ;
	state:state [
		<https://git.code.sf.net/p/qmidiarp#ARPPATTERN> "d(012)>h(123)>d(012)<d(234)>hh(23)(42)(12)(43)>d012342"
	] .
